/*
The following licence has been copied from
http://www.opensource.org/licenses/mit-license.html

Copyright (c) 2000, Peter Arthur Loeb

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package com.palserv.XMidi;

import org.w3c.dom.Document;

/**
 * This is the interface to implement when you
 * want to include an XML parser.
 * The XSilfide class
 * {@link com.palserv.XMidi.XSilfide XSilfide} class
 * doc has details.  Also the
 * main package description.
*/
public interface Parser {
/**
 * This method should be overridden to
 * invoke whatever is needed to implement
 * the parsing of an XML file by
 * the external parser.
 * @param String fid - meant to be a file name of an XML file, but could be an string.
 * It is passed on the command line as the first non-option argument.
 * @return com.w3c.dom.Document or a sub-class thereof.
 * @author Peter Arthur Loeb
*/
	public Document parseXML(String fid);

/**
 * This method should be overridden to
 * obtain a new Document from
 * the external parser.
 * @return com.w3c.dom.Document or a sub-class thereof.
 * @author Peter Arthur Loeb
*/
	public Document getNewDoc();
}
