package com.palserv.XMidi;

import org.xml.sax.Attributes;
import java.util.*;

/**
 * Implement the DELTA tag
 */
public class TagDELTA extends Tag {
	private String name = "DELTA";

	public void startElement(Attributes attr) {
		State state = State.getState();
		if (!state.chunkFlag) {
			Util.rpt("DELTA element only valid within a chunk");
		}
		if (!state.chunkType.equals("MTrk")) {
			Util.rpt("DELTA element must be in MTrk chunk");
		}
		if (!state.getParent().equals("MTrk")) {
			Util.rpt("DELTA element must be child of MTrk");
		}
		String dtime = Util.getAttr(attr,"DTIME");
		byte[] hdt = Util.hexToBa(dtime,4);
		byte[] dt = Util.intToDelta(hdt);
		Util.wpt(dt);
//		  state.parent = "DELTA";
	}

/*
			} else if (elementName.equals("DELTA")) {
				if (!chunkFlag) {
					Util.rpt("DELTA element only valid within a chunk");
				}
				if (!chunkType.equals("MTrk")) {
					Util.rpt("DELTA element must be in MTrk chunk");
				}
				if (!parent.equals("MTrk")) {
					Util.rpt("DELTA element must be child of MTrk");
				}
				String dtime = elem.getAttribute("DTIME");
				byte[] hdt = Util.hexToBa(dtime,4);
				byte[] dt = intToDelta(hdt);
spt("Delta: "+dtime+", out = "+Util.baToHex(dt,0,dt.length - 1));
				wpt(dt);
*/
	public void endElement() {
	}

	public String createStartXML() {
		State state = State.getState();
		ArrayList<TagAttr> al = new ArrayList<TagAttr>();
		TagAttr dt = new TagAttr("DTIME", state.deltaLen);
		al.add(dt);
		String x = Util.makeTag(name, al, true);
		return x;
	}

	public String getName() {
		return name;
	}
}

