package com.palserv.XMidi;

import org.xml.sax.Attributes;
import java.util.*;

/**
 * Implement the STATUS tag
 */
public class TagSTATUS extends Tag {
	private String name = "STATUS";

	public void startElement(Attributes attr) {
		State state = State.getState();
		if (!state.chunkFlag) {
			Util.rpt("STATUS element only valid within a chunk");
		}
		if (!state.chunkType.equals("MTrk")) {
			Util.rpt("STATUS element must be in MTrk chunk");
		}
		if (!state.getParent().equals("DELTA")) {
			Util.rpt("STATUS element must be child of DELTA");
		}
		String sval = Util.getAttr(attr, "SVAL");
		Util.writeHex(sval,1);
		String sl = Util.getAttr(attr, "SLEN");
		state.slen = Util.stringToInt(sl);
		if (sval.equals("FF")) {
			String nmd = Util.getAttr(attr, "SNMT");
			Util.writeHex(nmd,1);
			byte[] hdt = Util.intToBa(state.slen,4);
			byte[] xdt = Util.intToDelta(hdt);
			Util.wpt(xdt);
			if (state.slen == 0) {
				state.edFlag = true;
			}
		} else if (sval.equals("F0")) {
			byte[] hdt = Util.intToBa(Util.stringToInt(sl),4);
			Util.wpt(Util.intToDelta(hdt));
		} else if (sval.equals("F6") | sval.equals("F8") |
				sval.equals("FA") | sval.equals("FB") |
				sval.equals("FC") | sval.equals("FE")) {
			state.edFlag = true;
		}
//		  state.parent = "STATUS";
	}
/*
			} else if (elementName.equals("STATUS")) {
				if (!chunkFlag) {
					Util.rpt("STATUS element only valid within a chunk");
				}
				if (!chunkType.equals("MTrk")) {
					Util.rpt("STATUS element must be in MTrk chunk");
				}
				if (!parent.equals("DELTA")) {
					Util.rpt("STATUS element must be child of DELTA");
				}
				sval = elem.getAttribute("SVAL");
				writeHex(sval,1);
				String sl = elem.getAttribute("SLEN");
				slen = stringToInt(sl);
spt("Status: "+sval+", len = "+slen);
				if (sval.equals("FF")) {
					String nmd = elem.getAttribute("SNMT");
					writeHex(nmd,1);
					byte[] hdt = Util.intToBa(slen,4);
					byte[] xdt = intToDelta(hdt);
					wpt(xdt);
					if (slen == 0) {
						edFlag = true;
					}
spt("Non-midi: "+nmd);
				} else if (sval.equals("F0")) {
					byte[] hdt = Util.intToBa(stringToInt(sl),4);
					wpt(intToDelta(hdt));
spt("Sysex");
				} else if (sval.equals("F6") | sval.equals("F8") |
						sval.equals("FA") | sval.equals("FB") |
						sval.equals("FC") | sval.equals("FE")) {
					edFlag = true;
spt("no data");
				}
*/
	public void endElement() {
	}

/*
				eStatus = addElem(xDoc, delta, "STATUS");
				addAttr(eStatus, "SNAM", state.snam);
				addAttr(eStatus, "SVAL", state.sval);
				addAttr(eStatus, "SLEN", ""+state.slen);
				if (!state.nmData.equals("")) {
					addAttr(eStatus, "SNMT", state.nmData);
				}
*/
	public String createStartXML() {
		State state = State.getState();
		ArrayList<TagAttr> attrs = new ArrayList<TagAttr>();
		TagAttr snam = new TagAttr("SNAM", state.snam);
		attrs.add(snam);
		TagAttr sval = new TagAttr("SVAL", state.sval);
		attrs.add(sval);
		TagAttr slen = new TagAttr("SLEN", ""+state.slen);
		attrs.add(slen);
		if (!state.nmData.equals("")) {
			TagAttr snmt = new TagAttr("SNMT", state.nmData);
			attrs.add(snmt);
		}
		String x = Util.makeTag(name, attrs, true);
		return x;
	}


	public String getName() {
		return name;
	}
}

