package com.palserv.XMidi;

import org.xml.sax.Attributes;

/**
 * Implement the AFTER tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagAFTER extends TagNOTE_OFF {
	private String name = "AFTER";

	public void startElement(Attributes attr, State state) {
		if (!state.chunkFlag) {
			Util.rpt("AFTER element only valid within a chunk");
		}
		if (!state.chunkType.equals("MTrk")) {
			Util.rpt("AFTER element must be in MTrk chunk");
		}
		if (!state.getParent().equals("CHANNEL")) {
			Util.rpt("AFTER element must be child of CHANNEL");
		}
		String pitch = Util.getAttr(attr, "PITCH");
		Util.wpt(Util.stringToInt(pitch), state);
		String pres = Util.getAttr(attr, "PRESSURE");
		Util.wpt(Util.stringToInt(pres), state);
	}

	public String getName() {
		return name;
	}
}

