package com.palserv.XMidi;

import org.xml.sax.Attributes;
import java.util.*;

/**
 * Implement the CHANNEL tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagCHANNEL extends Tag {
	private String name = "CHANNEL";

	public void startElement(Attributes attr, State state) {
		if (!state.chunkFlag) {
			Util.rpt("CHANNEL element only valid within a chunk");
		}
		if (!state.chunkType.equals("MTrk")) {
			Util.rpt("CHANNEL element must be in MTrk chunk");
		}
		if (!state.getParent().equals("DELTA") &&
				!state.getParent().equals("STATUS")) {
			Util.rpt("STATUS element must be child of " +
				"DELTA or STATUS");
		}
	}

	public String createStartXML(State state) {
		ArrayList<TagAttr> attrs = new ArrayList<TagAttr>();
		TagAttr typ = new TagAttr("TYPE", state.ctyp);
		attrs.add(typ);
		TagAttr num = new TagAttr("NUMBER", ""+state.cnum);
		attrs.add(num);
		StringBuffer x = new StringBuffer(Util.makeTag(name, attrs, true, state));
		state.indent ++;
		Tag sub = Tag.getTag(state.ctag);
		x.append(sub.createStartXML(state));
//		  x.append(sub.createEndXML(state));
		state.indent --;
		return x.toString();
	}

	public String getName() {
		return name;
	}
}

