package com.palserv.XMidi;

import org.xml.sax.Attributes;

/**
 * Implement the CONTROL tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagCONTROL extends TagNOTE_OFF {
	private String name = "CONTROL";

	public void startElement(Attributes attr, State state) {
		if (!state.chunkFlag) {
			Util.rpt("CONTROL element only valid within a chunk");
		}
		if (!state.chunkType.equals("MTrk")) {
			Util.rpt("CONTROL element must be in MTrk chunk");
		}
		if (!state.getParent().equals("CHANNEL")) {
			Util.rpt("CONTROL element must be child of CHANNEL");
		}
		String cnum = Util.getAttr(attr, "NUMBER");
		Util.wpt(Util.stringToInt(cnum), state);
		String val = Util.getAttr(attr, "VALUE");
		Util.wpt(Util.stringToInt(val), state);
	}

	public String getName() {
		return name;
	}
}

