package com.palserv.XMidi;

import org.xml.sax.Attributes;

/**
 * Implement the FORMAT tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagFORMAT extends Tag {
	String name = "FORMAT";

	public void startElement(Attributes attr, State state) {}

	public String createStartXML(State state) {
		StringBuffer x = new StringBuffer(Util.makeTag(name, null, true, state));
		state.indent ++;
		int midiFormat = Util.baToInt(state.dta,0,1);
		x.append(Util.makeIndent(state)+midiFormat+"\n");
		state.indent --;
		return x.toString();
	}

	public String getName() {
		return name;
	}

	public void doContent(String typ, State state) {
		if (!state.chunkFlag) {
			Util.rpt("FORMAT element only valid within a chunk");
		}
		if (!state.chunkType.equals("MThd")) {
			Util.rpt("FORMAT element must be in MThd chunk");
		}
		int midiFormat = Util.stringToInt(typ);
		Util.writeHalfWord(midiFormat, state);
	}
}
