package com.palserv.XMidi;

import org.xml.sax.Attributes;
import java.util.*;

/**
 * Implement the MThd tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagMThd extends Tag {
	String name = "MThd";

	public void startElement(Attributes attr, State state) {
		state.chunkFlag = true;
		state.chunkType = Util.getAttr(attr, "TYPE");
		Util.writeString(state.chunkType, 4, state);
		String ilen = Util.getAttr(attr, "LENGTH");
		state.chunkLen = Util.stringToInt(Util.getAttr(attr, "LENGTH"));
		Util.writeFullWord(state.chunkLen, state);
	}

	public String createStartXML(State state) {
		ArrayList<TagAttr> attrs = new ArrayList<TagAttr>();
		TagAttr typ = new TagAttr("TYPE", name);
		attrs.add(typ);
		TagAttr len = new TagAttr("LENGTH", ""+state.chunkLen);
		attrs.add(len);
		StringBuffer x = new StringBuffer(Util.makeTag(name, attrs, true, state));
		state.indent ++;
		Tag frm = Tag.getTag("FORMAT");
		x.append(frm.createStartXML(state));
		x.append(frm.createEndXML(state));
		frm = Tag.getTag("TRACKS");
		x.append(frm.createStartXML(state));
		x.append(frm.createEndXML(state));
		frm = Tag.getTag("PPNQ");
		x.append(frm.createStartXML(state));
		x.append(frm.createEndXML(state));
		state.indent --;
		return x.toString();
	}

	public String getName() {
		return name;
	}
}

