package com.palserv.XMidi;

import org.xml.sax.Attributes;
import java.util.*;

/**
 * Implement the MTrk tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagMTrk extends TagMThd {
	private String name = "MTrk";

	public String createStartXML(State state) {
		state.trkCount ++;
		if (state.trkCount > state.numTracks) {
			Util.rpt("too many tracks");
		}
		ArrayList<TagAttr> attrs = new ArrayList<TagAttr>();
		TagAttr typ = new TagAttr("TYPE", name);
		attrs.add(typ);
		TagAttr len = new TagAttr("LENGTH", ""+state.chunkLen);
		attrs.add(len);
		TagAttr trk = new TagAttr("NUMBER", ""+state.trkCount);
		attrs.add(trk);
		String x = Util.makeTag(name, attrs, true, state);
		return x;
	}

	public String getName() {
		return name;
	}
}

