package com.palserv.XMidi;

import org.xml.sax.Attributes;
import java.util.*;

/**
 * Implement the NOTE_OFF tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagNOTE_OFF extends Tag {
	private String name = "NOTE_OFF";

	public void startElement(Attributes attr, State state) {
		if (!state.chunkFlag) {
			Util.rpt("NOTE_OFF element only valid within a chunk");
		}
		if (!state.chunkType.equals("MTrk")) {
			Util.rpt("NOTE_OFF element must be in MTrk chunk");
		}
		if (!state.getParent().equals("CHANNEL")) {
			Util.rpt("NOTE_OFF element must be child of CHANNEL");
		}
		String pitch = Util.getAttr(attr,"PITCH");
		Util.wpt(Util.stringToInt(pitch), state);
		String vel = Util.getAttr(attr,"VELOCITY");
		Util.wpt(Util.stringToInt(vel), state);
	}

	public String createStartXML(State state) {
		ArrayList<TagAttr> attrs = new ArrayList<TagAttr>();
		TagAttr[] ta = new TagAttr[state.ctagnum];
		for (int c = 0; c < state.ctagnum; c ++) {
			ta[c] = new TagAttr(state.ctagAttr[c], state.ctagAttrVal[c]);
			attrs.add(ta[c]);
		}
		String x = Util.makeTag(getName(), attrs, false, state);
		return x;
	}

	public String getName() {
		return name;
	}
}

