package com.palserv.XMidi;

import org.xml.sax.Attributes;

/**
 * Implement the PRESSURE tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagPRESSURE extends TagNOTE_OFF {
	private String name = "PRESSURE";

	public void startElement(Attributes attr, State state) {
		if (!state.chunkFlag) {
			Util.rpt("PRESSURE element only valid within a chunk");
		}
		if (!state.chunkType.equals("MTrk")) {
			Util.rpt("PRESSURE element must be in MTrk chunk");
		}
		if (!state.getParent().equals("CHANNEL")) {
			Util.rpt("PRESSURE element must be child of CHANNEL");
		}
		String amt = Util.getAttr(attr, "AMOUNT");
		Util.wpt(Util.stringToInt(amt), state);
	}

	public String getName() {
		return name;
	}
}
