package com.palserv.XMidi;

import org.xml.sax.Attributes;

/**
 * Implement the PROGRAM tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagPROGRAM extends TagNOTE_OFF {
	private String name = "PROGRAM";

	public void startElement(Attributes attr, State state) {
		if (!state.chunkFlag) {
			Util.rpt("PROGRAM element only valid within a chunk");
		}
		if (!state.chunkType.equals("MTrk")) {
			Util.rpt("PROGRAM element must be in MTrk chunk");
		}
		if (!state.getParent().equals("CHANNEL")) {
			Util.rpt("PROGRAM element must be child of CHANNEL");
		}
		String patch = Util.getAttr(attr, "NUMBER");
		Util.wpt(Util.stringToInt(patch), state);
	}

	public String getName() {
		return name;
	}
}
