package com.palserv.XMidi;

import org.xml.sax.Attributes;

/**
 * Implement the STRINGREP tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagSTRINGREP extends Tag {
	private String name = "STRINGREP";

	public String createStartXML(State state) {
		StringBuffer bth = new StringBuffer("");
		bth.append(Util.makeTag(name, null, true, state));
		int bpl = 32;
		int r = state.chunkLen % bpl;
		int n = state.chunkLen / bpl;
		state.indent ++;
		for (int i = 0; i < n; i ++) {
			int strt = i * bpl;
			bth.append(Util.makeIndent(state)+
				Util.baToString(state.dta,strt,strt + bpl - 1)+"\n");
		}
		if (r > 0) {
			int strt = n * bpl;
			bth.append(Util.makeIndent(state)+
				Util.baToString(state.dta,strt,strt + r - 1)+"\n");
		}
		state.indent --;
		return bth.toString();
	}

	public String getName() {
		return name;
	}
}

