package com.palserv.XMidi;

import org.xml.sax.Attributes;
import java.util.*;

/**
 * Implement the TIME_SIG tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagTIME_SIG extends Tag {
	private String name = "TIME_SIG";

	public void startElement(Attributes attr, State state) {}

	public String createStartXML(State state) {
		ArrayList<TagAttr> attrs = new ArrayList<TagAttr>();
		TagAttr nn = new TagAttr("NN", ""+state.timeSig[0]);
		attrs.add(nn);
		TagAttr dd = new TagAttr("DD", ""+state.timeSig[1]);
		attrs.add(dd);
		TagAttr cc = new TagAttr("CC", ""+state.timeSig[2]);
		attrs.add(cc);
		TagAttr bb = new TagAttr("BB", ""+state.timeSig[3]);
		attrs.add(bb);
		TagAttr sig = new TagAttr("SIG", ""+state.timeSig[0]+"/"+state.timeSig[4]);
		attrs.add(sig);
		String x = Util.makeTag(name, attrs, false, state);
		return x;
	}

	public String getName() {
		return name;
	}
}
