package com.palserv.XMidi;

import org.xml.sax.Attributes;

/**
 * Implement the TRACKS tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagTRACKS extends TagFORMAT {
	private String name = "TRACKS";

	public String createStartXML(State state) {
		StringBuffer x = new StringBuffer(Util.makeTag(name, null, true, state));
		state.indent ++;
		state.numTracks = Util.baToInt(state.dta,2,3);
		x.append(Util.makeIndent(state)+state.numTracks+"\n");
		state.indent --;
		return x.toString();
	}

	public String getName() {
		return name;
	}
}
