package com.palserv.XMidi;

import org.xml.sax.Attributes;

/**
 * Implement the WHEEL tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagWHEEL extends TagNOTE_OFF {
	private String name = "WHEEL";

	public void startElement(Attributes attr, State state) {
		if (!state.chunkFlag) {
			Util.rpt("WHEEL element only valid within a chunk");
		}
		if (!state.chunkType.equals("MTrk")) {
			Util.rpt("WHEEL element must be in MTrk chunk");
		}
		if (!state.getParent().equals("CHANNEL")) {
			Util.rpt("WHEEL element must be child of CHANNEL");
		}
		String amt = Util.getAttr(attr, "AMOUNT");
		int a = Util.stringToInt(amt);
		int b = a;
		int c = a;
		b &= 127;
		c >>= 7;
		Util.wpt(c, state);
		Util.wpt(b, state);
	}

	public String getName() {
		return name;
	}
}
