package com.palserv.XMidi;

import org.xml.sax.Attributes;
import java.util.*;

/**
 * Implement the XMidi tag.
 * This class must be public in order for the
 * {@link com.palserv.XMidi.Tag#getTag(String) Tag.getTag}
 * method to work.
 * This is one of many Tag subclasses which are all similar.
 * Please see the
 * {@link com.palserv.XMidi.Tag Tag}
 * document and the
 * {@link com.palserv.XMidi.iTag iTag}
 * document for more details.
 */
public class TagXMidi extends Tag {
	private String name = "XMidi";

	public void startElement(Attributes attr, State state) {
		// validate version
		String ver = Util.getAttr(attr, "VERSION");
		if (!ver.equals(Version._VERSION)) {
			Util.rpt("wrong version; expecting "+Version._VERSION+", got "+ver);
		}
	}

	public String createStartXML(State state) {
		ArrayList<TagAttr> attrs = new ArrayList<TagAttr>();
		TagAttr ta = new TagAttr("VERSION", Version._VERSION);
		attrs.add(ta);
		String x = Util.makeTag(name, attrs, true, state);
		return x;
	}

	public String getName() {
		return name;
	}
}
