/*
The following licence has been copied from
http://www.opensource.org/licenses/mit-license.html

Copyright (c) 2005, Peter Arthur Loeb

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package com.palserv.XMidi;

/**
 * internal class
 * <p>
 * NOT FOR EXTERNAL USE
 * <p>
 * This class is more like a data structure.
 * It contains variables, but no methods.
 * It is used to pass these variables
 * as a return from the
 * {@link com.palserv.XMidi.MX#deltaToInt(byte[],int) MX.deltaToInt}
 * method.
*/
public class ByteLen {
/**
 * Default constructor.
 * As of Jan 8, 2001, this is not used.
*/
	public ByteLen() {}

/**
 * Constructor used in the
 * {@link com.palserv.XMidi.MX#deltaToInt(byte[],int) MX.deltaToInt}
 * method to create this class, which it then returns.
 * @param b - a byte array; used to set ba
 * @param l - a length; used to set len
*/
	public ByteLen(byte[] b, int l) {
		ba = b;
		len = l;
	}

/**
 * A byte array.
*/
	public byte[] ba;

/**
 * As used in the
 * {@link com.palserv.XMidi.MX#deltaToInt(byte[],int) MX.deltaToInt}
 * method, it is the length of the delta field being converted,
 * not the length of the array.
 * <p>
 * There is nothing about this class that requires that this variable
 * be used in this way.  It could be any int.
*/
	public int len;
}
