/*
The following licence has been copied from
http://www.opensource.org/licenses/mit-license.html

Copyright (c) 2005, Peter Arthur Loeb

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package com.palserv.XMidi;

import java.io.*;
import java.util.*;

/**
 * Hold state data for calls to Tag subclasses.
 */
public class State {
	// state for XM
	FileOutputStream fos;
	boolean chunkFlag = false;
	String chunkType;
	Stack<String> parents;
	boolean edFlag;
	String content;

	// state for MX
	FileInputStream fis;
	PrintWriter pw;
	int indent;
	byte[] dta;
	int numTracks;
	int trkCount;
	String deltaLen;
	int[] timeSig;
	String snam;
	String sval;
	String nmData;
	String edata;
	String ctyp;
	String cnum;
	String ctag;
	String ctagAttr[];
	String ctagAttrVal[];
	int ctagnum;
	byte[] hdr;
	boolean verbose = false;
	boolean testMode = false;

	// state for both XM and MX
	int chunkLen;
	int slen;

/**
 * Peek at the top item in the parent stack.
 */
	public String getParent() {
		return parents.peek();
	}
}
